'use strict';

var Devebot = require('devebot');
var lodash = Devebot.require('lodash');
var logolite = Devebot.require('logolite');
var Buffer = global.Buffer || require('buffer').Buffer;
var misc = {};

misc.isBoolean = function (a) {
  return typeof a === 'boolean';
};

misc.isFunction = function (a) {
  return typeof a === 'function';
};

misc.isNumber = function (a) {
  return typeof a === 'number';
};

misc.isObject = function (a) {
  return a && typeof a === 'object';
};

misc.isInteger = function (a) {
  return Number.isInteger(a);
};

misc.isPositiveInteger = function (a) {
  return Number.isInteger(a) && a > 0;
};

misc.isNegativeInteger = function (a) {
  return Number.isInteger(a) && a < 0;
};

misc.isString = function (a) {
  return typeof a === 'string';
};

misc.isEmpty = lodash.isEmpty;
misc.merge = lodash.merge;
misc.pick = lodash.pick;

misc.getLogger = function () {
  return logolite.LogAdapter.getLogger();
};

misc.getTracer = function () {
  return logolite.LogTracer.ROOT;
};

misc.stringify = function (a) {
  return typeof a === 'string' ? a : JSON.stringify(a);
};

misc.bufferify = function (a) {
  return a instanceof Buffer ? a : new Buffer(this.stringify(a));
};

module.exports = misc;